﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Security;
using System.Security.Cryptography;

namespace WinCSPRNG
{
    class Program
    {
        static void Main(string[] args)
        {
            // Size of output file in bytes.
            const int fileByteSize = 12582912;
            // Size of elementary block.
            const int rngBlockSize = 1024;
            // Elementatry block count.
            const int blockCount = fileByteSize / rngBlockSize;

            // Create a byte array to hold the random block.
            byte[] randomNumber = new byte[rngBlockSize];

            string outputFileName = "output.bin";

            try
            {
                // Create a new instance of the RNGCryptoServiceProvider. 
                RNGCryptoServiceProvider rng = new RNGCryptoServiceProvider();
                // Create a new instance of the ordinary random number generator. 
                //Random rnd = new Random();

                using (FileStream fs = new FileStream(outputFileName, FileMode.Create))
                {
                    for (int i = 0; i < blockCount; i++)
                    {
                        // Fill the array with a random value (cryptographicaly strong).
                        rng.GetBytes(randomNumber);
                        //  Fill the array with a random value (ordinary generator).
                        //rnd.NextBytes(randomNumber);

                        fs.Write(randomNumber, 0, rngBlockSize);
                    }

                    fs.Close();
                }

            }
            catch (CryptographicException ex)
            {
                Console.WriteLine(ex.Message);
            }
            catch (IOException ex)
            {
                Console.WriteLine(ex.Message);
            }
            catch(Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }
    }
}
